#include <REGtenxTM52F5288C.H>
#include<intrins.h>

#define   uchar    unsigned char
#define   uint     unsigned int   
#define   ulong    unsigned long  

unsigned int xdata eeprom_address1  _at_   0X3FE0; 



 

ulong   ADCio,ADCvbg ,VCC ;

uint  adcdata,ADCvbgtrim,V_io; 
 


void delay_10nop(void)
{
    _nop_();
	  _nop_();
		_nop_();
	  _nop_();
	  _nop_();
	  _nop_();
		_nop_();
	  _nop_();
   	_nop_();
	  _nop_();
}
	



void SYS_INT(void)
{
	
 
  
	 P4MOD=0x03; //P4.0 adc8
		

}

 
uint ADConversion(uchar channel)  //channel?????
{                             
	  uint adc = 0;
	  uint  temph=0;
    uint  templ=0; 
	 
    CHSEL=channel<<4;       //
    ADSOC=1;                //
    while(ADSOC);           //
 
    templ =ADCL;
    temph =ADCDH;         //

    adc = (temph<<4)&0xff0;
	  adc |= templ>>4;
     

	return adc;	
	
}



uint CHECK_V_io()	
{
	   uint   ADC_OUT;
	   ulong  ADC_OUT_TEMP;
  
	  ADC_OUT_TEMP=ADCio*500/ADCvbg*ADCvbgtrim ; //5VŴ100=500 //3D7=VT 
	  ADC_OUT_TEMP=ADC_OUT_TEMP/0x1000;   
	
 	

	  ADC_OUT = (uint) ADC_OUT_TEMP;  //ulong to uint
	  
   	return(ADC_OUT);	

}


uint read_iap()   
{
	 uint read_iap_data_temp; 
	 
EA=0;
	SELFCK=0;
	INTE1=(INTE1&~IAPWE_Mask)|IAPWE_En;// enble IAP 
	
	while((SWCMD&0x01)==0)	  // OPEN IAP 		   
		{	
		SWCMD=0x65;		
		}  
		
	 
		read_iap_data_temp=eeprom_address1;
	
		
		SWCMD=0x00; // cloes IAP
		INTE1=(INTE1&~IAPWE_Mask)|IAPWE_Dis;	 //disable iap
    SELFCK=1;
EA=1;
		
		return(read_iap_data_temp);
}


void main()
{
	
	 uchar i;
	 _nop_();
	 for(i=0;i<50;i++);
	
	 CLKPSC_L=0;     //ϵȷƵ 
	 delay_10nop();  //ƵҪӳ10NOP
	 SELFCK=1;       //е
	 delay_10nop();   //ʱ10NOP
	 SYS_INT();
	 
	 
	
	//ADC
	 OPTION=0x04 ;   //ADC  DIV16
  
	ADCvbgtrim=read_iap(); //read iap ADCvbgtrim		
			while(1)
			
				{
		
				ADCio = ADConversion(8); //check adc8
				delay_10nop();	
				
			  ADCvbg = ADConversion(11);	 //check adc vbg
				delay_10nop();
		
					
				V_io = CHECK_V_io() ;	//output che  voltage  ex 159=1.59V
				
					
				VCC	=ADCvbgtrim;   
				VCC	=VCC*5000/ADCvbg; // MCU VCC  voltage		
					
					
					
					
					
					
				}
				
				
	
}		
	