
#include <REGtenxTM52F5288C.H>
#include<intrins.h>

#define   uchar    unsigned char
#define   uint     unsigned int   
#define   ulong    unsigned long  

uint read_iap_data_temp;
unsigned int xdata eeprom_address1  _at_   0X3FE0; 



 
ulong			ADC_IN,	ADCvbgtrim ;

uint			adcdata ; 

uchar			key_old,key_timer;

#define		key									  P3_5
#define		write_iap_ok_led			P3_6  

bit				f_to_writer_iap;
bit				key_has_work;
 


void delay_10nop(void)
{
    _nop_();
	  _nop_();
		_nop_();
	  _nop_();
	  _nop_();
	  _nop_();
		_nop_();
	  _nop_();
   	_nop_();
	  _nop_();
}
	



void SYS_INT(void)
{
	
 
   P4MOD=0x03; //P4.0 adc8
	
	 P3MODH=0x20; //P3.6  led,   p3.5 KEY
	
	 
		

}

 
uint ADConversion(uchar channel)  //channel
{                             
	  uint adc = 0;
	  uint  temph=0;
    uint  templ=0; 
	 
    CHSEL=channel<<4;       //
	  _nop_();
  	_nop_();
	
    ADSOC=1;   
  	_nop_();
    while(ADSOC);           //
 
    templ =ADCL;
    temph =ADCDH;         //

    adc = (temph<<4)&0xff0;
	  adc |= templ>>4;
     

	return adc;	
	
}


void read_iap(void)
{
	 
	 
EA=0;
	 SELFCK=0;
	 INTE1=(INTE1&~IAPWE_Mask)|IAPWE_En;//enable IAP
	
	while((SWCMD&0x01)==0)	   //open IAP 		  
		{	
		SWCMD=0x65;		
		}  
		
	 
		read_iap_data_temp=eeprom_address1;
	
		
		SWCMD=0x00;  //close IAP
		INTE1=(INTE1&~IAPWE_Mask)|IAPWE_Dis;	//disable Iap
    SELFCK=1;
EA=1;
}




void writer_iap(uint ADCvbgtrim  )
{
EA=0;
	  SELFCK=0;
	  INTE1=(INTE1&~IAPWE_Mask)|IAPWE_En;//enable IAP 
	 
 	while((SWCMD&0x01)==0)	  //open IAP 		   
		{	
		SWCMD=0x65;		
		}  
		
	 
		eeprom_address1=ADCvbgtrim  ;
	
		
		SWCMD=0x00; //close IAP
    SELFCK=1;
		INTE1=(INTE1&~IAPWE_Mask)|IAPWE_Dis;	 //disable Iap

EA=1;
}




void scan_key()
{
   uchar i;
	 
	   
	      for(i=0;i<250;i++);
	      
      if(key==key_old)
		       	{ key_timer++; }
			     else
					  { 
						key_timer=0;
						key_old=key;								
						}
						
						
       if(key_timer<50)  //ɨ50Ȧ ٰȥ԰50С
			      {
						 return;
					  }
			     else
					  {
						key_timer=0;	 
 
					 if( (key_old==0)&&(key_has_work==0) )
						    
					       {   
                 f_to_writer_iap=1; 
								 key_has_work=1;
								 
                 }
								 
					 if (key_old==1)
						    
					       {   
                 key_has_work=0;
							
                 }			 
								 
						 
				  }  
						  
						    
						   
					 
					 
				
				

}


 void  writer_iap_loop()   
					 {
					  uchar i;
	             
 					      ADCvbgtrim =0;
				        for(i=0;i<16;i++)
				         {
					       ADCvbgtrim  =ADCvbgtrim +ADConversion(11);	
				         delay_10nop();
								 }
								ADCvbgtrim =ADCvbgtrim >>4;  //5V¶ VBGIAP  ںʹ
						    writer_iap(ADCvbgtrim );
					 }		 
								 




void main()
{  uchar i;
	 _nop_();
	 for(i=0;i<250;i++);
		 
	 read_iap();
	
	
	 CLKPSC_L=0;     //ϵ2Ƶ 
	 delay_10nop();  //ƵҪӳ10NOP
	 SELFCK=1;       //е
	 delay_10nop();   //ʱ10NOP
	 SYS_INT();
	 //ADC
	 OPTION=0x04 ;   //ADC  DIV16
	 write_iap_ok_led=0;
	
			while(1)
			  {   
   
					        scan_key();
					
					         if(f_to_writer_iap)
									 {
										    uint j;
										      f_to_writer_iap=0;
										      write_iap_ok_led=0;
										 
										      writer_iap_loop();  //writer_iap
										      read_iap();         //read_iap
										      
										       if(ADCvbgtrim ==read_iap_data_temp) //CHECK iap is write OK?
										              { 
																		for(j=0;j<10000;j++);
                                    write_iap_ok_led=1;   //write ok, to  puton the LED
                                  }   
																	 
									 }

					
					
				}
				
				
	
}		
	